------------------------------------- VARIABLES ---------------------------------------
WHISPLISTNAME = "WhispList";
WHISPLISTVERS = "2.2";
WLSETTINGS = "WL_"..GetCVar("realmName");
------- valeurs par defaut
local defShowList = 1; -- etat visible ou masque
local defDeployList = 1; -- etat agrandi ou reduit
local defTailleListe = 10; -- nbre joueurs dans liste
local defSortAlpha = false; -- classement alpha
local defMoreParam1 = 0; -- pour plus tard
local defMoreParam2 = 0; -- pour plus tard
local defWlX = -60; -- pos X frame TopRight
local defWlY = -190; -- pos Y frame TopRight
-------
WLTABLEPLAYERS = {};
WLTABLEPLAYERSTIME = {};
WLTABLEBTNS = {};
WLBTNNUM = 0;
-------
WhispListSaved = {};
WhispListSaved[WLSETTINGS] = {};
WhispListDatas = {};
WhispListPlayersTimeSaved = {};
-------
local enTest = false;
local junkCapture = false;

---------------------------------------------------------------------------------------
-------------------------- EVENEMENTS / COMMANDES /BINDINGS ---------------------------
function chargementWhispList()
	------------- slash commandes
	SlashCmdList["WHISPLISTSHOW"] = wlShowHide;
		SLASH_WHISPLISTSHOW1 = "/whisplist";
		SLASH_WHISPLISTSHOW2 = "/wlist";
	SlashCmdList["WHISPLISTSORT"] = wlSortList;
		SLASH_WHISPLISTSORT1 = "/wlsort";
	SlashCmdList["WHISPLISTNUM"] = wlDefNum;
		SLASH_WHISPLISTNUM1 = "/wlnumber";
		SLASH_WHISPLISTNUM2 = "/wlnum";
	SlashCmdList["WHISPLISTLOAD"] = wlChargeListe;
		SLASH_WHISPLISTLOAD1 = "/wlload";
	SlashCmdList["WHISPLISTRESET"] = wlResetAll;
		SLASH_WHISPLISTRESET1 = "/wlreset";
	SlashCmdList["WHISPLISTHELP"] = wlHelpVers;
		SLASH_WHISPLISTHELP1 = "/wlhelp";
		
	SlashCmdList["WLDEBUG"] = wlDebug;
		SLASH_WLDEBUG1 = "/wlx";
	SlashCmdList["WHISPLISTTESTAUTO"] = wlTestAutoWisp; -- dvlpt
		SLASH_WHISPLISTTESTAUTO1 = "/wlauto";
	SlashCmdList["WHISPLISTTESTTABLE"] = wlTestTable; -- dvlpt
		SLASH_WHISPLISTTESTTABLE1 = "/wltable";

	-------------- bindings
	BINDING_HEADER_WHISPLIST = WHISPLISTNAME
	BINDING_NAME_WLSHOW = BIND_NAME_WHISPLISTSHOW
	BINDING_NAME_WLRESIZE = BIND_NAME_WHISPLISTRESIZE
	BINDING_NAME_WLSORT = BIND_NAME_WHISPLISTSORT
	
	-------------- evenements
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_WHISPER_INFORM");
	this:RegisterEvent("PLAYER_LOGOUT");
	--this:RegisterEvent("PLAYER_LEAVING_WORLD");
	--this:RegisterEvent("CHAT_MSG_SYSTEM");
end

---------------------------------------------------------------------------------------
---------------------------------- MAJ MURMURES ---------------------------------------
function evenementWhispList()
	if (event == "VARIABLES_LOADED") then
		if (DEFAULT_CHAT_FRAME) then wlEchoVersion(true); end;
		WhispListDatas = WhispListSaved[WLSETTINGS];
		if (WhispListDatas == nil or WhispListDatas["showList"] == nil) then
			if (enTest) then echo(WHISPLISTNAME.." === CHARGEMENT DATAS VIDE ==="); end;
			initDatas();	
		end;
		showBtns(false);
		if (WhispListDatas["showList"] == 1) then WhispListFrame:Show(); end;
		WLListe:SetHeight((WhispListDatas["whispNumber"] * 12) + 15); -- 12 = interligne
		if (WhispListDatas["deployList"] == 1) then WLListe:Show(); end;
	elseif (event == "CHAT_MSG_WHISPER") then
		wlMajListeRecu(arg1,arg2);
	elseif (event == "CHAT_MSG_WHISPER_INFORM") then
		wlMajListeEnvoi(arg1,arg2,arg3);
	elseif (event == "PLAYER_LOGOUT") then
		WhispListPlayersTimeSaved = WLTABLEPLAYERSTIME;
	--elseif (event == "PLAYER_LEAVING_WORLD") then
	--elseif (event == "CHAT_MSG_SYSTEM") then
	--	wlJoueurParti(arg1);
	end;
end

function wlMajListeRecu(arg1,arg2)
	-- interlocuteur = arg2
	majTableMurmures(arg2,"I");
end

function wlMajListeEnvoi(arg1,arg2,arg3)
	-- interlocuteur = arg2
	majTableMurmures(arg2,"O");
end

function wlJoueurParti(arg1)
	if (string.find(arg1,WLPLAYERDISCONNECTED,1,true) ~= nil) then
		local nomJoueur = string.sub(arg1,1,string.find(arg1," ",1,true) - 1);
		if (enTest) then echo(WHISPLISTNAME.."==="..nilSiNul(nomJoueur).."===DECO."); end;
		wlVirerJoueurSuite(nomJoueur);
	end;
end

---------------------------------------------------------------------------------------
------------------------------------ ACTIONS ------------------------------------------
function envoiMurmure(numLiJoueur)
	-- commence un murmure au joueur choisi dans liste
	local nomJoueur = string.sub(WLTABLEPLAYERS[numLiJoueur],1,-3);
	if (nomJoueur == nil or nomJoueur == "") then
		echo(WHISPLISTNAME..": "..ERRORLIST.." [1000]","orange");
	else
		wlTapeMessage("/w "..nomJoueur.." ");
	end;
end

function whoJoueur(numLiJoueur)
	-- lance une requete who sur le joueur choisi dans liste
	local nomJoueur = string.sub(WLTABLEPLAYERS[numLiJoueur],1,-3);
	if (nomJoueur == nil or nomJoueur == "") then
		echo(WHISPLISTNAME..": "..ERRORLIST.." [1001]","orange");
	else
		SendWho(nomJoueur);
	end;
end

function wlVirerJoueur(numLiJoueur)
	local nomJoueur = string.sub(WLTABLEPLAYERS[numLiJoueur],1,-3);
	if (string.sub(WLTABLEPLAYERS[numLiJoueur],-1) == "I") then -- si couleur "recu" : changement couleur
		local tailleChaine = string.len(WLTABLEPLAYERS[numLiJoueur]);
		WLTABLEPLAYERS[numLiJoueur] = string.sub(WLTABLEPLAYERS[numLiJoueur],1,tailleChaine - 1).."O";
		getglobal("WLBtnLine"..numLiJoueur.."_Text"):SetTextColor(0.8,0.8,0.8,1);
		local numLi = numLigneTime(nomJoueur);
		if (numLi > 0) then
			tailleChaine = string.len(WLTABLEPLAYERSTIME[numLi]);
			WLTABLEPLAYERSTIME[numLi] = string.sub(WLTABLEPLAYERSTIME[numLi],1,tailleChaine - 1).."O";
		end;
	else -- sinon :cherche le nom du joueur a retirer de la liste
		wlVirerJoueurSuite(nomJoueur);
	end;
end

function wlVirerJoueurSuite(nomJoueur)
	-- retire le joueur de la liste
	if (nomJoueur ~= nil and nomJoueur ~= "") then
		local numLi = numLigneTime(nomJoueur);
		if (numLi > 0) then
			for i = numLi,table.getn(WLTABLEPLAYERSTIME) - 1,1 do
				WLTABLEPLAYERSTIME[i] = WLTABLEPLAYERSTIME[i + 1];
			end;
			WLTABLEPLAYERSTIME[table.getn(WLTABLEPLAYERSTIME)] = nil;
			table.sort(WLTABLEPLAYERSTIME); -- secu
			------ construction table noms et liste joueurs (btns)
			constructionTableJoueurs();
		else
			--echo(WHISPLISTNAME..": "..ERRORLIST.." [1002]","orange");
			--non : sinon erreur quand maj auto apres deco joueur
		end;
	else
		echo(WHISPLISTNAME..": "..ERRORLIST.." [1003]","orange");
	end;
end

function wlShowHide()
	if (WhispListFrame:IsVisible()) then
		showBtns(false);
		WLListe:Hide();
		WhispListFrame:Hide();
		WhispListDatas["showList"] = 0;
	else
		WhispListFrame:Show();
		WLListe:Show();
		constructionTableJoueurs();
		WhispListDatas["showList"] = 1;
	end;
	WhispListSaved[WLSETTINGS] = WhispListDatas;
end

function wlAgrandir()
	-- agrandit ou reduit la liste
	if (WLListe:IsVisible()) then
		showBtns(false);
		WhispListDatas["deployList"] = 0;
		WLListe:Hide();
	else
		WLListe:Show();
		WhispListDatas["deployList"] = 1;
		constructionTableJoueurs();
	end;
	WhispListSaved[WLSETTINGS] = WhispListDatas;
end

function wlSortList()
	WhispListDatas["sortAlpha"] = not WhispListDatas["sortAlpha"];
	WhispListSaved[WLSETTINGS] = WhispListDatas;
	constructionTableJoueurs();
end

function wlDefNum(nbre)
	local valeur;
	if (nbre == nil or nbre == "") then
		valeur = defTailleListe;
	else
		valeur = strToNumber(nbre);
		if (valeur < 3) then valeur = 3; end;
		if (valeur > defTailleListe) then valeur = defTailleListe; end;
	end;
	if (enTest) then echo(WHISPLISTNAME.."===NBRE="..nilSiNul(valeur).."==="); end;
	WhispListDatas["whispNumber"] = valeur;
	WhispListSaved[WLSETTINGS] = WhispListDatas;
	constructionTableJoueurs(true);
end

function wlChargeListe()
	if (WhispListPlayersTimeSaved ~= nil) then
		WLTABLEPLAYERSTIME = WhispListPlayersTimeSaved;
		constructionTableJoueurs();
	else
		echo(WHISPLISTNAME..": "..SAVEEMPTY,"red");
	end;
end

function wlResetAll()
	initDatas();
	WLTABLEPLAYERSTIME = {};
	constructionTableJoueurs();
	WhispListFrame:ClearAllPoints();
	WhispListFrame:SetPoint("TOPRIGHT","UIParent","TOPRIGHT",defWlX,defWlY);
	WLListe:Show();
	WhispListFrame:Show();
end

---------------------------------------------------------------------------------------
------------------------------------ FCNS INTERNES ------------------------------------
function majTableMurmures(nomJoueur,sens)
	if (not junkCapture) then
		local numLi = numLigneTime(nomJoueur);
		if numLi > 0 then
			------ joueur deja liste
			WLTABLEPLAYERSTIME[numLi] = time()..";"..nomJoueur.." "..sens;
			if (enTest) then echo(WHISPLISTNAME.."==="..nomJoueur.."=deja dans liste : "..numLi.."="..sens.."==="); end;
		else
			------ construction table temps et noms
			if (table.getn(WLTABLEPLAYERSTIME) >= defTailleListe) then
				-- manque de place : virer le plus ancien
				table.sort(WLTABLEPLAYERSTIME);
				for i = 1,defTailleListe - 1,1 do
					WLTABLEPLAYERSTIME[i] = WLTABLEPLAYERSTIME[i + 1];
				end;
				WLTABLEPLAYERSTIME[defTailleListe] = time()..";"..nomJoueur.." "..sens;
			else
				-- ajout simple dans liste
				WLTABLEPLAYERSTIME[table.getn(WLTABLEPLAYERS) + 1] = time()..";"..nomJoueur.." "..sens;
			end;
			------ construction table noms et liste joueurs (btns)
		end;
		constructionTableJoueurs();
	else
		WLTABLEPLAYERSTIME[1] = (time() - 10)..";".."Elleasure O";
		WLTABLEPLAYERSTIME[2] = (time() - 9)..";".."Torbek O";
		WLTABLEPLAYERSTIME[3] = (time() - 8)..";".."Numeror O";
		WLTABLEPLAYERSTIME[4] = (time() - 7)..";".."Deedoohangus O";
		WLTABLEPLAYERSTIME[5] = (time() - 6)..";".."Usgorod I";
		WLTABLEPLAYERSTIME[6] = (time() - 5)..";".."Demetreus I";
		WLTABLEPLAYERSTIME[7] = (time() - 4)..";".."Izengard I";
		WLTABLEPLAYERSTIME[8] = (time() - 3)..";".."Dinadan I";
		WLTABLEPLAYERSTIME[9] = (time() - 2)..";".."Lewelorn O";
		WLTABLEPLAYERSTIME[10] = (time() - 1)..";".."Fafner I";
		constructionTableJoueurs();
	end;
end

function constructionTableJoueurs(rafraichir)
	------ construction table noms
	WLTABLEPLAYERS = {};
	local cpt = 1;
	for i = 1,table.getn(WLTABLEPLAYERSTIME),1 do
		if (i > table.getn(WLTABLEPLAYERSTIME) - WhispListDatas["whispNumber"]) then
			WLTABLEPLAYERS[cpt] = string.sub(WLTABLEPLAYERSTIME[i],string.find(WLTABLEPLAYERSTIME[i],";",1,true) + 1);
			cpt = cpt + 1;
		end;
	end;
	if (WhispListDatas["sortAlpha"]) then table.sort(WLTABLEPLAYERS); end;
	------ construction texte boutons
	showBtns(false);
	if (rafraichir) then
		WLListe:Hide();
		WLListe:SetHeight((WhispListDatas["whispNumber"] * 12) + 15); -- 12 = interligne
		WLListe:Show();
	else
		WLListe:SetHeight((WhispListDatas["whispNumber"] * 12) + 15); -- 12 = interligne
	end;
	for i = 1,table.getn(WLTABLEPLAYERS),1 do
		if (string.sub(WLTABLEPLAYERS[i],-1) == "I") then
			getglobal("WLBtnLine"..i.."_Text"):SetTextColor(1,1,0.4,1); -- recu = changer couleur
		else
			getglobal("WLBtnLine"..i.."_Text"):SetTextColor(0.8,0.8,0.8,1); -- envoi = couleur par defaut
		end;
		getglobal("WLBtnLine"..i.."_Text"):SetText(string.sub(WLTABLEPLAYERS[i],1,-3));
		if (WhispListDatas["deployList"] == 1) then getglobal("WLBtnLine"..i):Show(); end;
	end;
end

function showBtns(etat)
	if (etat) then
		for i = 1,defTailleListe,1 do
			if (WLTABLEPLAYERS[i] ~= nil and WLTABLEPLAYERS[i] ~= "") then
				getglobal("WLBtnLine"..i):Show();
			else
				getglobal("WLBtnLine"..i):Hide();
			end;
		end;
	else
		for i = defTailleListe,1,-1 do
			getglobal("WLBtnLine"..i):Hide();
		end;
	end;
	if (enTest) then
		local test = WHISPLISTNAME.."=";
		for i = defTailleListe,1,-1 do
			if (getglobal("WLBtnLine"..i):IsVisible()) then
				test = test..i.."Vis=";
			else
				test = test..i.."Hid=";
			end;
		end;
		echo(test);
	end;
end

function numLigneTime(nomJoueur)
	-- renvoit le numero dans la table principale d'apres un nom
	if (nomJoueur ~= nil and nomJoueur ~= "") then
		for i = 1,table.getn(WLTABLEPLAYERSTIME),1 do
			if (string.find(WLTABLEPLAYERSTIME[i],";"..nomJoueur.." ",1,true) ~= nil) then return i; end;
		end;
	end;
	return 0;
end

function initDatas()
	WhispListDatas = {};
	WhispListDatas["showList"] = defShowList;
	WhispListDatas["deployList"] = defDeployList;
	WhispListDatas["sortAlpha"] = defSortAlpha;
	WhispListDatas["whispNumber"] = defTailleListe;
	WhispListDatas["moreParam1"] = defMoreParam1;
	WhispListDatas["moreParam2"] = defMoreParam2;
	WhispListDatas["wlX"] = defWlX;
	WhispListDatas["wlY"] = defWlY;
	WhispListSaved[WLSETTINGS] = WhispListDatas;
end

function wlTapeMessage(prefixe)
	-- tape le debut du message dans la Chat Box pour ouvrir un canal
	if (not ChatFrameEditBox:IsVisible()) then
		ChatFrame_OpenChat(prefixe);
	else
		ChatFrameEditBox:SetText(prefixe);
	end;
	ChatEdit_ParseText(ChatFrame1.editBox,0);
end

---------------------------------------------------------------------------------------
---------------------------------------- DVLPT ----------------------------------------
function wlDebug()
	enTest = not enTest;
	if (enTest) then
		echo(WHISPLISTNAME..": debugg ON.","green");
	else
		echo(WHISPLISTNAME..": debugg OFF.","gray");
	end;
end

function wlTestAutoWisp()
	SendChatMessage("=== This is an auto-whisper test","WHISPER",this.language,UnitName("player"));
end

function wlTestTable()
	for i = 1,defTailleListe,1 do
		echo("==="..i.."="..nilSiNul(WLTABLEPLAYERSTIME[i]).."==="..nilSiNul(WLTABLEPLAYERS[i]).."===");
	end;
end

---------------------------------------------------------------------------------------
-------------------------------------- LIBRAIRIE --------------------------------------
function wlEchoVersion(chargement)
	if (chargement) then
		DEFAULT_CHAT_FRAME:AddMessage(WHISPLISTNAME.." "..WHISPLISTVERS.." loaded.".." "..WLMSG,0.1,0.6,0.5);
	else
		DEFAULT_CHAT_FRAME:AddMessage(WHISPLISTNAME.." version "..WHISPLISTVERS.." "..WLMSG,0.4,0.5,0.9);
	end; 
end

function echo(chaine,nomCouleur)
	local coulr,coulg,coulb; -- couleurs
	if (nomCouleur == "red") then
		coulr,coulg,coulb = 1,0,0;
	elseif (nomCouleur == "green") then
		coulr,coulg,coulb = 0,1,0;
	elseif (nomCouleur == "blue") then
		coulr,coulg,coulb = 0.3,0.3,0.8;
	elseif (nomCouleur == "orange") then
		coulr,coulg,coulb = 0.8,0.3,0.1;
	elseif (nomCouleur == "yellow") then
		coulr,coulg,coulb = 1,1,0;
	elseif (nomCouleur == "grey" or nomCouleur == "gray") then
		coulr,coulg,coulb = 0.6,0.6,0.6;
	else
		coulr,coulg,coulb = 1,1,1;
	end;
	
	if (DEFAULT_CHAT_FRAME) then ChatFrame1:AddMessage(chaine,coulr,coulg,coulb); end;
end

function arrondi(valeur)
	if (valeur - math.floor(valeur) > 0.5) then valeur = valeur + 0.5;end;
	return (math.floor(valeur));
end

function strToNumber(chaine)
	local valeur = tonumber(string.gsub(string.gsub(chaine,"\"",""),"\'",""),10);
	if (valeur == nil) then valeur = 0; end;
	return valeur;
end

function truncChaine(chaine,taille)
	if (string.len(chaine) > taille) then
		return (string.sub(chaine,1,taille - 3).."...");
	else
		return chaine;
	end;
end

function nilSiNul(valeur)
	if (valeur == nil) then return "NIL"; else return valeur; end;
end

function inversionValeur(valeur)
	return(abs(valeur - 1));
end

function attribueBinaire(valeur)
	if (valeur == 1) then return (1); else return (0); end;
end

---------------------------------------------------------------------------------------
------------------------------------- AIDE ONLINE -------------------------------------
function wlHelpVers()
	wlEchoVersion();
	echo(WLSLASHCMDS,"gray");
end

---------------------------------------------------------------------------------------
